(defsystem :obj
  :description "Lisp object library"
  :depends-on (:std :quri)
  :serial t
  :components ((:module "meta"
                :components ((:file "pkg")
                             (:file "sealed")
                             (:file "stealth")
                             (:file "typed")
                             (:file "filtered")
                             (:file "fast")
                             (:file "lazy")
                             (:file "overloaded")
                             (:file "stored")
                             (:file "dynamic")))
               (:file "pkg")
               (:module "hash"
                :components ((:file "hasher")
                             (:file "chash")
                             (:file "map")
                             (:file "set")
                             (:file "castable")))
               (:file "id")
               (:module "uri"
                :components ((:file "pkg")
                             (:file "domain")
                             (:file "uri")
                             (:file "mask")
                             (:file "state")
                             (:file "parse")
                             (:file "print")
                             (:file "path")
                             (:file "intern")))
               (:file "url")
               (:file "seq")
               (:module "tree"
                :components ((:file "node")
                             (:file "avl")
                             (:file "redblack")
                             (:file "brother")
                             (:file "btree")))
               (:module "graph"
                :components ((:file "pkg")))
               (:file "unit")
               (:file "equiv")
               (:module "color"
                :components ((:file "color")
                             (:file "util")
                             (:file "x11")
                             (:file "palette")))
               (:module "time"
                :components ((:file "local")
                             (:file "util")))
               (:file "uuid")
               (:file "build")
               (:file "ast")
               (:file "config")
               (:file "plan")
               (:file "schema")
               (:file "query")
               (:file "db")
               (:file "secret")
               (:file "store")
               (:file "srv")
               (:file "obj"))
  :in-order-to ((test-op (test-op "obj/tests"))))

(defsystem :obj/tests
  :depends-on (:rt :obj)
  :components ((:file "tests"))
  :perform (test-op (o c) (symbol-call :rt :do-tests :obj)))
