;; (push :inspect *features*)
(defsystem :skel
  :version "0.1.0"
  :maintainer "ellis <ellis@rwest.io>"
  :bug-tracker "https://vc.compiler.company/comp/core/issues"
  :depends-on (:uiop :asdf :sb-posix :sb-bsd-sockets :sb-concurrency :cl-ppcre :std
                     :obj :dat :cli :organ :doc :vc
                     :pod :net :box :rdb
                     (:feature :ext :krypt)
                     (:feature :ext :packy)
                     (:feature :gui :gui)
                     (:feature :clim :clouseau))
  :serial t
  :components 
  ((:module "core"
    :serial t
    :components 
    ((:file "pkg")
     (:file "condition")
     (:file "proto")
     (:file "header")
     (:file "var")
     (:file "obj")
     (:file "component")
     (:file "rule")
     (:file "project")
     (:file "print")
     (:file "fs")
     (:file "schema")
     (:file "db")
     (:file "log")
     (:file "util")
     (:file "vm")))
   (:module "comp"
    :components
    ((:file "pkg")
     (:file "asd")
     (:file "cargo")
     (:file "container")
     (:file "org")
     (:file "dir-locals")
     (:file "makefile")))
   (:file "pkg")
   (:file "srv")
   (:file "infer")
   (:module "net"
    :components
    ((:file "var")
     (:file "proto")
     (:file "server")
     (:file "client")))
   (:module "tools"
    :components
    ((:file "pkg")
     (:file "deploy" :if-feature :deploy)
     (:file "view" :if-feature :clim)))
   (:module "ext"
    :components
    ((:file "pkg")
     (:file "asdf")
     (:file "krypt")
     (:file "packy"))
    :if-feature :ext)
   (:file "cli")
   (:file "skel"))
  :in-order-to ((test-op (test-op "skel/tests"))))

(defsystem :skel/tests
  :depends-on (:rt :skel)
  :components ((:file "tests"))
  :perform (test-op (o c) (symbol-call :rt :do-tests :skel)))
